*** ao_alsa.c.old	Fri Nov  9 17:27:03 2001
--- ao_alsa.c	Fri Nov  9 17:39:53 2001
***************
*** 36,40 ****
  
  #define AO_ALSA_BUF_SIZE 32768
! 
  
  static char *ao_alsa_options[] = {"card","dev","buf_size"};
--- 36,40 ----
  
  #define AO_ALSA_BUF_SIZE 32768
! /* #define INSANE_VERBOSITY */
  
  static char *ao_alsa_options[] = {"card","dev","buf_size"};
***************
*** 52,56 ****
  };
  
- 
  typedef struct ao_alsa_internal
  {
--- 52,55 ----
***************
*** 68,71 ****
--- 67,74 ----
  	snd_pcm_t *handle;
  
+ #ifdef INSANE_VERBOSITY
+ 	fprintf(stderr,"ao_plugin_test()\n");
+ #endif
+ 
  	if (snd_pcm_open(&handle, 0, 0, 
  			 SND_PCM_OPEN_PLAYBACK | SND_PCM_OPEN_NONBLOCK) != 0)
***************
*** 80,83 ****
--- 83,91 ----
  ao_info *ao_plugin_driver_info(void)
  {
+ 
+ #ifdef INSANE_VERBOSITY
+ 	fprintf(stderr,"ao_plugin_driver_info()\n");
+ #endif
+ 
  	return &ao_alsa_info;
  }
***************
*** 88,91 ****
--- 96,103 ----
  	ao_alsa_internal *internal;
  
+ #ifdef INSANE_VERBOSITY
+ 	fprintf(stderr,"ao_plugin_device_init()\n");
+ #endif
+ 
  	internal = (ao_alsa_internal *) malloc(sizeof(ao_alsa_internal));
  
***************
*** 106,109 ****
--- 118,126 ----
  {
  	ao_alsa_internal *internal = (ao_alsa_internal *) device->internal;
+ 
+ #ifdef INSANE_VERBOSITY
+ 	fprintf(stderr,"ao_plugin_set_option()\n");
+ #endif
+ 
  	if (!strcmp(key, "card"))
  		internal->card = atoi(value);
***************
*** 123,126 ****
--- 140,148 ----
  	int err;
  
+ 
+ #ifdef INSANE_VERBOSITY
+ 	fprintf(stderr,"ao_plugin_open()\n");
+ #endif
+ 
  	memset(&param, 0, sizeof(param));
  
***************
*** 146,150 ****
  		return 0;
  
! 	// Finish filling in the parameter structure
  	param.format.rate = format->rate;
  
--- 168,172 ----
  		return 0;
  
! 	/* Finish filling in the parameter structure */
  	param.format.rate = format->rate;
  
***************
*** 189,200 ****
  
  
! int _alsa_write_buffer(ao_alsa_internal *s)
  {
  	snd_pcm_channel_status_t status;
  	snd_pcm_t *pcm_handle = s->pcm_handle;
  	int len = s->buf_end;
  
  	s->buf_end = 0;
! 	snd_pcm_write(pcm_handle, s->buf, len);
  	memset(&status, 0, sizeof(status));
  	if (snd_pcm_channel_status(pcm_handle, &status) < 0) {
--- 211,249 ----
  
  
! static int
! _alsa_write_buffer(ao_alsa_internal *s)
  {
  	snd_pcm_channel_status_t status;
  	snd_pcm_t *pcm_handle = s->pcm_handle;
  	int len = s->buf_end;
+ 	ssize_t remaining, snd_pcm_write_ret;
+ 
+ 
+ #ifdef INSANE_VERBOSITY
+ 	fprintf(stderr,"_alsa_write_buffer()\n");
+ #endif
  
  	s->buf_end = 0;
! 
! 	snd_pcm_write_ret = 0;
! 	remaining = len;
! 	while ((snd_pcm_write_ret >= 0) && (remaining > 0)) {
! 		while ((snd_pcm_write_ret = snd_pcm_write(pcm_handle, s->buf + (len - remaining), remaining)) == -EINTR)
! 			;
! 
! #ifdef INSANE_VERBOSITY
! 		fprintf(stderr,"snd_pcm_write(pcm_handle, s->buf, %d) returns: %d",len,snd_pcm_write_ret);
! 
! 		if (snd_pcm_write_ret < 0)
! 			fprintf(stderr," (%s)\n",strerror(-snd_pcm_write_ret));
! 		else
! 			fprintf(stderr,"\n");
! 
! #endif
! 
! 		if (snd_pcm_write_ret > 0)
! 			remaining -= snd_pcm_write_ret;
! 	}
! 
  	memset(&status, 0, sizeof(status));
  	if (snd_pcm_channel_status(pcm_handle, &status) < 0) {
***************
*** 231,234 ****
--- 280,287 ----
  	int ok = 1;
  
+ #ifdef INSANE_VERBOSITY
+ 	fprintf(stderr,"ao_plugin_play()\n");
+ #endif
+ 
  	while (packed < num_bytes && ok) {
  		/* Pack the buffer */
***************
*** 256,260 ****
--- 309,333 ----
  	int result;
  
+ 
+ #ifdef INSANE_VERBOSITY
+ 	fprintf(stderr,"ao_plugin_close()\n");
+ #endif
+ 
  	/* Clear buffer */
+ 
+ 	if (internal->buf_end < internal->buf_size) {
+ 		/* pad the buffer to meet the N*fragment_size requirement */
+ 		memset(internal->buf + internal->buf_end, 0,
+ 			internal->buf_size - internal->buf_end);
+ 
+ #ifdef INSANE_VERBOSITY
+ 	fprintf(stderr,"buf_end (%d) < buf_size (%d), padding with %d bytes.\n",
+ 		internal->buf_end,internal->buf_size,
+ 		internal->buf_size - internal->buf_end);
+ #endif
+ 
+ 		internal->buf_end = internal->buf_size;	
+ 	}
+ 
  	result = _alsa_write_buffer(internal);
  	snd_pcm_close(internal->pcm_handle);
***************
*** 268,271 ****
--- 341,348 ----
  {
  	ao_alsa_internal *internal = (ao_alsa_internal *) device->internal;
+ 
+ #ifdef INSANE_VERBOSITY
+ 	fprintf(stderr,"ao_plugin_device_clear()\n");
+ #endif
  
  	free(internal);
